///*
// * File:   zadani1.cpp
// * Author: Pavel Strnad
// *
// * Created on 7. listopad 2011, 18:59
// *
// * 1. Implementujte funkci calculate, ktera ma tri parametry, prvni dva jsou typu double,
// *    treti je typu ukazatel na funkci, ktera ma dva parametry typu double a vraci double.  
// * 2. Upravte funkci calculate na calculate_add_vec tak, aby její třetí parametr byl vector funkcí 
// *	stejného typu jako add. Postupně se zavolá každá funkce ve vektoru s parametry arg1, arg2 a výsledky se sečtou. 
// *	Bude tedy platit: 
// *	calculate(arg1, arg2, add) == calculate_add_vec(arg1, arg2, vec) iff add e vec ^ vec.size==1
// *	
// * 3. Zobecněte funkci  calculate_add_vec na funkci calculate_fun_vec tak, aby její čtvrtý parametr(op) byl typu jako fun a pátý parametr typu double (neutral) - neutrální prvek operace op. 
// *	Pokud není pátý parametr předán, pak je implicitně 0.0. Funkce calculate_fun_vec bude pracovat stejně jako calculate_add_vec, ale místo sčítání se použije op. 
// *	Bude tedy platit: 
// *	calculate_add_vec(arg1, arg2, vec) == calculate_fun_vec(arg1, arg2, vec, add, 0.0)

#include <iostream>
#include <vector>

using namespace std;

typedef double (*FP)(double, double);

double add(double x, double y)
{
	return x + y;
}

double mul(double x, double y)
{
	return x * y;
}

double calculate(double x, double y, FP fun)
{
	return fun(x, y);
}

double calculate_fun_vec(double x, double y, vector<FP> &vec, FP op, double neutral = 0.0)
{
	double result = neutral;
	for (vector<FP>::iterator it = vec.begin() ; it != vec.end(); ++it)
    	result = op(result, (*it)(x, y));
    return result;
}

double calculate_add_vec(double x, double y, vector<FP> &vec)
{
	return calculate_fun_vec(x, y, vec, add);
}

int main(void) {
	vector<FP> vec;
	vec.push_back(add);
	vec.push_back(add);
	vec.push_back(mul);

	cout << calculate(2.5, 10.4, add) << endl; // = 12.9
	cout << calculate_add_vec(2.5, 10.4, vec) << endl; // = 51.8
	cout << calculate_fun_vec(2.5, 10.4, vec, mul, 1.0) << endl; // = 4326.66

	return 0;
}